local tvRP = Proxy.getInterface("vRP")
local vRPserver = Tunnel.getInterface(GetCurrentResourceName(), GetCurrentResourceName())

local MarketPos = {
    {vec3(24.357809066772,-1345.6363525391,29.497024536133)},
    {vec3(1135.5777587891,-981.7802734375,46.415824890137)},
    {vec3(1163.5391845703,-323.54055786133,69.205101013184)},
    {vec3(374.19073486328,327.50756835938,103.56641387939)},
    {vec3(-1223.1805419922,-907.38470458984,12.326351165771)},
    {vec3(-1486.7648925781,-379.5530090332,40.163410186768)},
    {vec3(-2967.880859375,390.78762817383,15.043308258057)},
    {vec3(547.98834228516,2669.7578125,42.156513214111)},
    {vec3(1393.2392578125,3605.1728515625,34.980911254883)},
    {vec3(1960.5089111328,3741.8410644531,32.343761444092)},
    {vec3(547.98834228516,2669.7578125,42.156513214111)},
    {vec3(1393.2392578125,3605.1728515625,34.980911254883)},
}

-- Create blips for each market location
Citizen.CreateThread(function()
    for _, pos in pairs(MarketPos) do
        local blip = AddBlipForCoord(pos[1].x, pos[1].y, pos[1].z)
        SetBlipSprite(blip, 52) -- Sprite ID for shop/market
        SetBlipDisplay(blip, 4)
        SetBlipScale(blip, 0.7)
        SetBlipColour(blip, 2) -- Green color
        SetBlipAsShortRange(blip, true)
        BeginTextCommandSetBlipName("STRING")
        AddTextComponentString("Magazin Alimentar")
        EndTextCommandSetBlipName(blip)
    end
end)

local function isNearMarket()
    for _, pos in pairs(MarketPos) do
        if #(pos[1] - GetEntityCoords(PlayerPedId())) <= 2.5 then
            return true
        end
    end

    return false
end

local canOpen, isOpened = false, false
Citizen.CreateThread(function()
    local wasNearMarket = false

    while true do
       Wait(0)

        if isNearMarket() then
            if not wasNearMarket then
                TriggerEvent("eternity:sendTextUI", "open", {key = "E", text ="Pentru a accesa Magazin Alimentar!"})
                canOpen = true
                wasNearMarket = true
            end
        else
            if wasNearMarket then
                canOpen = false
                wasNearMarket = false
                TriggerEvent("eternity:sendTextUI", "close")
            end
        end
    end
end)


RegisterCommand("+Markets", function()
    if canOpen and not isOpened then
        isOpened = true
        SendNUIMessage({
            act = "interactMarkets"
        })
    end
end)

RegisterKeyMapping("+Markets", "Open Market", "keyboard", "E")

RegisterNUICallback("marketBuy", function(data, cb)
    if data.price > 0 then
        vRPserver.marketBuy({data})
    end
end)

RegisterNUICallback("setFocus", function(data, cb) 
    if not data.state then
        isOpened = false
    end
    SetNuiFocus(data.state, data.state) 
end)